#!/bin/bash

# usage: ./ranger-compress.sh ranger-compress.filelist &

[ $# -ne 1 ] && echo 'Please provide filelist to compress' && exit 1
[ ! -r $1 ] && echo "Provided file '$1' is not readable" && exit 1
FILELIST=$1

KEYTAB=$HOME/.safe/dtvcompress.keytab
DEL_ORIGIN=YES
#DEL_ORIGIN=NO

mkdir -p $HOME/logs
export KRB5CCNAME=$HOME/.ranger-compress-ksession

trap '' HUP

# redirect all outputs (stdout and stderr) generated by this script to a specific log file
TS=$(date '+%y%m%d-%H%M')
SCRIPTNAME=$(basename ${0%.*}); exec >>$HOME/logs/${SCRIPTNAME}-${TS}.log 2>&1

check_set_ksession() {
  ! klist -s && echo 'about to set ksession' && kinit -kt $KEYTAB dtvcompress/admin
  ! klist -s && echo 'unable to set ksession; exiting...' && exit 1
}

post_process() {
  UNCOMPR=$1
  SUCCESS_FLAG=0

  # iterate on all files generated by pig script and check status
  for HDFS_FILE in $(hdfs dfs -ls "${UNCOMPR}_to_be_compressed" |tr -s ' ' |cut -d ' ' -f 8); do
    [ "x$(basename $HDFS_FILE)" == "x_SUCCESS" ] && echo 'success reached...' && SUCCESS_FLAG=1 && break
  done
  # if pig processing status is not success (ie. no _SUCCESS file has been generated), proceed no further and bail out
  [ "x$SUCCESS_FLAG" != "x1" ] && echo "pig job has failed for '$UNCOMPR'; not proceeding any further" && exit 1

  # iterate on all files, delete _SUCCESS file and move other files in the mother directory
  for HDFS_FILE in $(hdfs dfs -ls "${UNCOMPR}_to_be_compressed" |tr -s ' ' |cut -d ' ' -f 8); do
    HDFS_BASENAME=$(basename $HDFS_FILE)
    [ "x$HDFS_BASENAME" == "x_SUCCESS" ] && hdfs dfs -rm -skipTrash $HDFS_FILE && continue
    hdfs dfs -mv $HDFS_FILE ${UNCOMPR}_${HDFS_BASENAME}
  done

  # delete directory generated by pig script
  hdfs dfs -rmdir "${UNCOMPR}_to_be_compressed" && echo "zipped files moved and working dir '${UNCOMPR}_to_be_compressed' deleted..."

  # if user request for original file delete, proceed to file deletion
  [ "x$DEL_ORIGIN" == "xYES" ] && echo "proceed to '$UNCOMPR' deletion..." && hdfs dfs -rm -skipTrash $UNCOMPR

}


#LOG_TO_COMPRESS='hdfs://hdtvcluster01:8020/ranger/audit/hdfs/20200224/hdfs_ranger_audit_hdtvlx31.dns21.socgen.1.log'
for LOG_TO_COMPRESS in $(cat $FILELIST); do
  echo "*** $(date '+%Y-%m-%d %H:%M') - [START] - $LOG_TO_COMPRESS ***"
  check_set_ksession
#  ! pig -f $HOME/compressor_ranger/compressor_ranger.pig -param log=$LOG_TO_COMPRESS && continue
  ! pig -x mapreduce -f compressor_ranger_mapred.pig -param log=$LOG_TO_COMPRESS && continue
  post_process $LOG_TO_COMPRESS
  echo "*** $(date '+%Y-%m-%d %H:%M') - [END]   - $LOG_TO_COMPRESS ***"

done


